{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}
{%- import "src/_data_sharing.j2" as data_sharing with context -%}

{#- this file gathers all things that need to be done after all questionnaire answers have been read -#}
{#- -#}
{#- some info (like everything related to data sharing) can only dealt with at the end -#}
{#- since no answers are compulsory, we don't know when is the right time to do this -#}
{#- -#}
{#-  yes we could annotate a specific section, but even that would need to be answered -#}
{#- for the annotation in question to be processed... -#}
{#- -#}
{#- this way it is clean and simple(r) -#}

{%- set local_ns = namespace(description="data_sharing") -%}


{%- macro completeDistributionDataAccessDetails(globals, dmp_being_built) -%}
  {#- this is because there are two sections which deal with distribution.data_access: -#}
  {#- data processing and data storage -#}
  {#- since only one answer is required one needs to rank the answers gathered to come up with -#}
  {#- the required answer -#}
  {#- -#}
  {#- we decide that -#}
  {#- if there are contradictory answers, we issue an error message -#}
  {#- if for one distribution.site there exists an answer in the data storage section -#}
  {#- this answer takes precedence -#}
  {#- otherwise, we take the answer in the data processing section -#}


  
  {%- set data_processing_security_closed_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_processing_security_closed_sharing_distribution_items -%}
  {%- set data_processing_security_shared_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_processing_security_shared_sharing_distribution_items -%}
   {%- set data_processing_security_open_sharing_distribution_items = 
  globals.global_ns.dataset_vars.data_processing_security_open_sharing_distribution_items -%}

  {% set data_storage_closed_sharing_distribution_items =
  globals.global_ns.dataset_vars.data_storage_closed_sharing_distribution_items -%}
  {% set data_storage_shared_sharing_distribution_items =
  globals.global_ns.dataset_vars.data_storage_shared_sharing_distribution_items -%}
  {% set data_storage_open_sharing_distribution_items =
  globals.global_ns.dataset_vars.data_storage_open_sharing_distribution_items -%}

  {{ utils.deepCopy(globals.global_ns.dataset_vars.distribution_site_item) }}
  {%- set site_item = utils.global_ns.var_stack.pop() -%}

  {%- set dataset_name_list = globals.global_ns.dataset_vars.name_list -%}
  {{ utils.getSiteTitles(globals) }}
  {%- set site_title_list = utils.global_ns.var_stack.pop() -%}

  {%- for dataset_name in dataset_name_list -%}
    {#- all datasets have the same distributions... again, that might not be optimal -#}
    {%- for site_title in site_title_list -%}
      {%- do site_item.update({ "dataset_name" : dataset_name }) -%}
      {%- do site_item.update({ "site_title": site_title })  -%}
      
      {{ utils.getDistributionsFromSiteItem(globals, dmp_being_built, site_item) }}
      {%- set distributions = utils.global_ns.var_stack.pop() -%}

      {{ data_sharing.getSiteItemDataSharingAnswer(globals, site_item) }}
      {%- set answer = data_sharing.global_ns.var_stack.pop() -%}

      {%- for distribution in distributions -%}
        {%- do distribution.update({ "data_access" : answer }) -%}
      {%- endfor -%}
    {%- endfor -%}
  {%- endfor -%}
{%- endmacro -%}


{%- macro completeTimesFromReplies(dc, dmp_being_built) -%}
  {%- set all_creation_dates = [] -%}
  {%- for key, value in dc.replies.replies.items() -%}
    {% do all_creation_dates.append(value.created_at.strftime('%Y-%m-%d')) -%}
  {%- endfor -%}
  {#-   {{ "\nall_creation_dates " ~ all_creation_dates|sort }}-#}

  {%- if all_creation_dates|length > 0 -%}
    {%- set all_creation_dates = all_creation_dates|sort -%}
    {%- do dmp_being_built.update({ "created" : all_creation_dates|first }) -%}
    {%- do dmp_being_built.update({ "modified" : all_creation_dates|last })  -%}
  {%- endif -%}
{%- endmacro -%}


  
{%- macro completeTimesFromDC(dc, dmp_being_built) -%}
  {#- we'll pick the last questionnaire named version, if named versions exist -#}
  {%- if dc.qtn.versions -%}
    {%- set last_version = dc.qtn.versions|last -%}
    {%- do dmp_being_built.update({ "created" : last_version.created_at.strftime('%Y-%m-%d') }) -%}
    {%- do dmp_being_built.update({ "modified" : last_version.updated_at.strftime('%Y-%m-%d') })  -%}
  {%- else -%}
    {#- otherwise we'll get the dates when replies were created and pick the oldest and newest... -#}
    {#- dc.replies -#}
    {{ completeTimesFromReplies(dc, dmp_being_built) }}
  {%- endif -%}
  
{%- endmacro -%}




{%- macro completeFromDC(dc, globals, dmp_being_built) -%}
  {{  completeTimesFromDC(dc, dmp_being_built) }}
  {%- do dmp_being_built.update({ "title" : dc.qtn.name  }) -%}

  {%- do dmp_being_built.update({ "language" : globals.global_ns.hardcoded_vars.language }) -%}
{%- endmacro -%}




{%- macro completePopulatingDMPJSONObject(dc, globals, dmp_being_built) -%}
  {{ completeDistributionDataAccessDetails(globals, dmp_being_built) }}
  {{ completeFromDC(dc, globals, dmp_being_built) }} 
{%- endmacro -%}
